/*!
@ng-dynamic-forms/ui-bootstrap 6.0.0-beta 2018-03-28 22:05 UTC
Copyright (c) 2016-2017, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms'), require('@ng-dynamic-forms/core'), require('ngx-bootstrap/datepicker'), require('ngx-bootstrap/timepicker'), require('@angular/common'), require('angular2-text-mask')) :
    typeof define === 'function' && define.amd ? define(['exports', '@angular/core', '@angular/forms', '@ng-dynamic-forms/core', 'ngx-bootstrap/datepicker', 'ngx-bootstrap/timepicker', '@angular/common', 'angular2-text-mask'], factory) :
    (factory((global.ngDF = global.ngDF || {}, global.ngDF.bootstrapUI = {}),global.ng.core,global.ng.forms,global.ngDF.core,global['ngx-bootstrap'].umd,global['ngx-bootstrap'].umd,global.ng.common,global['angular2-text-mask']));
}(this, (function (exports,core,forms,core$1,datepicker,timepicker,common,angular2TextMask) { 'use strict';

    var __extends = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapCheckboxComponent = /** @class */ (function (_super) {
        __extends(DynamicBootstrapCheckboxComponent, _super);
        function DynamicBootstrapCheckboxComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapCheckboxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-checkbox",
                        template: "<div [formGroup]=\"group\" [class.disabled]=\"model.disabled\" [ngClass]=\"getClass('element', 'control') || 'checkbox'\"><label><input type=\"checkbox\" [checked]=\"model.checked\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [indeterminate]=\"model.indeterminate\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" [value]=\"model.value\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"><span [innerHTML]=\"model.label\" [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></span></label></div>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapCheckboxComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapCheckboxComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
        };
        return DynamicBootstrapCheckboxComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$1 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapDatePickerComponent = /** @class */ (function (_super) {
        __extends$1(DynamicBootstrapDatePickerComponent, _super);
        function DynamicBootstrapDatePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapDatePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-datepicker",
                        template: "<div [formGroup]=\"group\" class=\"input-group\"><input bsDatepicker class=\"form-control\" #bsDatepicker=\"bsDatepicker\" [autofocus]=\"model.autoFocus\" [bsConfig]=\"model.getAdditional('bsConfig', {containerClass: model.getAdditional('containerClass', 'theme-green'), showWeekNumbers: model.getAdditional('showWeekNumbers', true)})\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxDate]=\"model.max\" [minDate]=\"model.min\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [outsideClick]=\"model.getAdditional('outsideClick', true)\" [placeholder]=\"model.placeholder\" [placement]=\"model.getAdditional('placement', 'bottom')\" [readonly]=\"model.readOnly\" [required]=\"model.required\" (bsValueChange)=\"onChange($event)\" (onHidden)=\"onCustomEvent($event, 'onHidden')\" (onShown)=\"onCustomEvent($event, 'onShown')\"><div *ngIf=\"model.toggleLabel\" class=\"input-group-btn\"><button *ngIf=\"model.toggleIcon\" class=\"btn\" (click)=\"bsDatepicker.toggle()\"><img [src]=\"model.toggleIcon\"></button> <button *ngIf=\"model.toggleLabel\" class=\"btn\" (click)=\"bsDatepicker.toggle()\">{{ model.toggleLabel }}</button></div></div>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapDatePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapDatePickerComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "customEvent": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
            "bsDatePicker": [{ type: core.ViewChild, args: [datepicker.BsDatepickerDirective,] },],
        };
        return DynamicBootstrapDatePickerComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$2 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapInputComponent = /** @class */ (function (_super) {
        __extends$2(DynamicBootstrapInputComponent, _super);
        function DynamicBootstrapInputComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapInputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-input",
                        template: "<div [formGroup]=\"group\" [class.input-group]=\"model.prefix || model.suffix\"><div *ngIf=\"model.prefix\" class=\"input-group-addon\" [innerHTML]=\"model.prefix\"></div><input class=\"form-control\" [attr.accept]=\"model.accept\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [autocomplete]=\"model.autoComplete\" [autofocus]=\"model.autoFocus\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"><div *ngIf=\"model.suffix\" class=\"input-group-addon\" [innerHTML]=\"model.suffix\"></div><datalist *ngIf=\"this.model.hasList\" [id]=\"model.listId\"><option *ngFor=\"let option of model.list\" [value]=\"option\"></option></datalist></div>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapInputComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapInputComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
        };
        return DynamicBootstrapInputComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$3 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapRadioGroupComponent = /** @class */ (function (_super) {
        __extends$3(DynamicBootstrapRadioGroupComponent, _super);
        function DynamicBootstrapRadioGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapRadioGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-radio-group",
                        template: "<fieldset role=\"radiogroup\" [dynamicId]=\"bindId && model.id\" [formGroup]=\"group\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [tabindex]=\"model.tabIndex\" (change)=\"onChange($event)\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><div *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option') || 'radio'\"><label><input type=\"radio\" [formControlName]=\"model.id\" [name]=\"model.name\" [value]=\"option.value\" (blur)=\"onBlur($event)\" (focus)=\"onFocus($event)\"><span [innerHTML]=\"option.label\"></span></label></div></fieldset>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapRadioGroupComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapRadioGroupComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
        };
        return DynamicBootstrapRadioGroupComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$4 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapSelectComponent = /** @class */ (function (_super) {
        __extends$4(DynamicBootstrapSelectComponent, _super);
        function DynamicBootstrapSelectComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapSelectComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-select",
                        template: "<ng-container [formGroup]=\"group\"><select class=\"form-control\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [required]=\"model.required\" [tabindex]=\"model.tabIndex\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"><option *ngFor=\"let option of model.options$ | async\" [disabled]=\"option.disabled\" [ngValue]=\"option.value\">{{ option.label }}</option></select></ng-container>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapSelectComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapSelectComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
        };
        return DynamicBootstrapSelectComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$5 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapTextAreaComponent = /** @class */ (function (_super) {
        __extends$5(DynamicBootstrapTextAreaComponent, _super);
        function DynamicBootstrapTextAreaComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapTextAreaComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-textarea",
                        template: "<ng-container [formGroup]=\"group\"><textarea class=\"form-control\" [dynamicId]=\"bindId && model.id\" [cols]=\"model.cols\" [formControlName]=\"model.id\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"></textarea></ng-container>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapTextAreaComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapTextAreaComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
        };
        return DynamicBootstrapTextAreaComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$6 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapTimePickerComponent = /** @class */ (function (_super) {
        __extends$6(DynamicBootstrapTimePickerComponent, _super);
        function DynamicBootstrapTimePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapTimePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-timepicker",
                        template: "<ng-container [formGroup]=\"group\"><timepicker [arrowkeys]=\"model.getAdditional('arrowkeys', true)\" [dynamicId]=\"bindId && model.id\" [formControlName]=\"model.id\" [hourStep]=\"model.getAdditional('hourStep', 1)\" [max]=\"model.max\" [min]=\"model.min\" [mousewheel]=\"model.getAdditional('mousewheel', true)\" [minuteStep]=\"model.getAdditional('minuteStep', 1)\" [ngClass]=\"getClass('element', 'control')\" [secondsStep]=\"model.getAdditional('secondsStep', 1)\" [showMeridian]=\"model.meridian\" [showSeconds]=\"model.showSeconds\" [showSpinners]=\"model.getAdditional('spinners', true)\"></timepicker></ng-container>",
                        changeDetection: core.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapTimePickerComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapTimePickerComponent.propDecorators = {
            "bindId": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
            "bsTimePicker": [{ type: core.ViewChild, args: [timepicker.TimepickerComponent,] },],
        };
        return DynamicBootstrapTimePickerComponent;
    }(core$1.DynamicFormControlComponent));

    var __extends$7 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapFormControlContainerComponent = /** @class */ (function (_super) {
        __extends$7(DynamicBootstrapFormControlContainerComponent, _super);
        function DynamicBootstrapFormControlContainerComponent(componentFactoryResolver, layoutService, validationService) {
            var _this = _super.call(this, componentFactoryResolver, layoutService, validationService) || this;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.asBootstrapFormGroup = true;
            _this.bindId = true;
            _this.context = null;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicBootstrapFormControlContainerComponent.prototype, "componentType", {
            get: /**
             * @return {?}
             */
            function () {
                return this.layoutService.getCustomComponentType(this.model) || bootstrapUIFormControlMapFn(this.model);
            },
            enumerable: true,
            configurable: true
        });
        DynamicBootstrapFormControlContainerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form-control",
                        template: "<div [class.form-group]=\"asBootstrapFormGroup || getClass('element', 'container').includes('form-group')\" [class.has-error]=\"showErrorMessages\" [formGroup]=\"group\" [ngClass]=\"[getClass('element', 'container'), getClass('grid', 'container')]\"><label *ngIf=\"!isCheckbox && hasLabel\" [for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label><ng-container *ngTemplateOutlet=\"templates[0]?.templateRef; context: model\"></ng-container><div [ngClass]=\"getClass('grid', 'control')\"><ng-container #componentViewContainer></ng-container><div *ngIf=\"isFormArray\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"getClass('element', 'control')\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\"><dynamic-bootstrap-form-control *ngFor=\"let _model of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" (bsEvent)=\"onCustomEvent($event)\"></dynamic-bootstrap-form-control><ng-container *ngTemplateOutlet=\"templates[2]?.templateRef; context: groupModel\"></ng-container></div></div><fieldset *ngIf=\"isFormGroup\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\"><legend *ngIf=\"model.legend\" [innerHTML]=\"model.legend\"></legend><dynamic-bootstrap-form-control *ngFor=\"let _model of model.group\" [asBootstrapFormGroup]=\"false\" [group]=\"control\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" (bsEvent)=\"onCustomEvent($event)\"></dynamic-bootstrap-form-control></fieldset><span *ngIf=\"hasHint\" class=\"help-block\" [innerHTML]=\"model.hint\" [ngClass]=\"getClass('element', 'hint')\"></span></div><ul *ngIf=\"showErrorMessages\" class=\"has-error\" [ngClass]=\"[getClass('element', 'errors'), getClass('grid', 'errors')]\"><li *ngFor=\"let message of errorMessages\" class=\"help-block\">{{ message }}</li></ul><ng-container *ngTemplateOutlet=\"templates[1]?.templateRef; context: model\"></ng-container><ng-content></ng-content></div>"
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapFormControlContainerComponent.ctorParameters = function () { return [
            { type: core.ComponentFactoryResolver, },
            { type: core$1.DynamicFormLayoutService, },
            { type: core$1.DynamicFormValidationService, },
        ]; };
        DynamicBootstrapFormControlContainerComponent.propDecorators = {
            "contentTemplateList": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
            "inputTemplateList": [{ type: core.Input, args: ["templates",] },],
            "asBootstrapFormGroup": [{ type: core.Input },],
            "bindId": [{ type: core.Input },],
            "context": [{ type: core.Input },],
            "group": [{ type: core.Input },],
            "layout": [{ type: core.Input },],
            "model": [{ type: core.Input },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
            "customEvent": [{ type: core.Output, args: ["bsEvent",] },],
            "componentViewContainerRef": [{ type: core.ViewChild, args: ["componentViewContainer", { read: core.ViewContainerRef },] },],
        };
        return DynamicBootstrapFormControlContainerComponent;
    }(core$1.DynamicFormControlContainerComponent));
    /**
     * @param {?} model
     * @return {?}
     */
    function bootstrapUIFormControlMapFn(model) {
        switch (model.type) {
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return DynamicBootstrapCheckboxComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return DynamicBootstrapDatePickerComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                return DynamicBootstrapInputComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return DynamicBootstrapRadioGroupComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return DynamicBootstrapSelectComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return DynamicBootstrapTextAreaComponent;
            case core$1.DYNAMIC_FORM_CONTROL_TYPE_TIMEPICKER:
                return DynamicBootstrapTimePickerComponent;
            default:
                return null;
        }
    }

    var __extends$8 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicBootstrapFormComponent = /** @class */ (function (_super) {
        __extends$8(DynamicBootstrapFormComponent, _super);
        function DynamicBootstrapFormComponent(formService, layoutService) {
            var _this = _super.call(this, formService, layoutService) || this;
            _this.formService = formService;
            _this.layoutService = layoutService;
            _this.blur = new core.EventEmitter();
            _this.change = new core.EventEmitter();
            _this.focus = new core.EventEmitter();
            _this.customEvent = new core.EventEmitter();
            return _this;
        }
        DynamicBootstrapFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: "dynamic-bootstrap-form",
                        template: "<dynamic-bootstrap-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\" [group]=\"formGroup\" [hidden]=\"model.hidden\" [layout]=\"formLayout\" [model]=\"model\" [ngClass]=\"[getClass(model,'element','host'), getClass(model,'grid','host')]\" [templates]=\"templates\" (blur)=\"onEvent($event, 'blur')\" (change)=\"onEvent($event, 'change')\" (focus)=\"onEvent($event, 'focus')\" (bsEvent)=\"onEvent($event, 'custom')\"></dynamic-bootstrap-form-control>"
                    },] },
        ];
        /** @nocollapse */
        DynamicBootstrapFormComponent.ctorParameters = function () { return [
            { type: core$1.DynamicFormService, },
            { type: core$1.DynamicFormLayoutService, },
        ]; };
        DynamicBootstrapFormComponent.propDecorators = {
            "formGroup": [{ type: core.Input, args: ["group",] },],
            "formModel": [{ type: core.Input, args: ["model",] },],
            "formLayout": [{ type: core.Input, args: ["layout",] },],
            "blur": [{ type: core.Output },],
            "change": [{ type: core.Output },],
            "focus": [{ type: core.Output },],
            "customEvent": [{ type: core.Output, args: ["bsEvent",] },],
            "templates": [{ type: core.ContentChildren, args: [core$1.DynamicTemplateDirective,] },],
            "components": [{ type: core.ViewChildren, args: [DynamicBootstrapFormControlContainerComponent,] },],
        };
        return DynamicBootstrapFormComponent;
    }(core$1.DynamicFormComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var DynamicFormsBootstrapUIModule = /** @class */ (function () {
        function DynamicFormsBootstrapUIModule() {
        }
        DynamicFormsBootstrapUIModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            datepicker.BsDatepickerModule.forRoot(),
                            timepicker.TimepickerModule.forRoot(),
                            angular2TextMask.TextMaskModule,
                            core$1.DynamicFormsCoreModule
                        ],
                        declarations: [
                            DynamicBootstrapCheckboxComponent,
                            DynamicBootstrapDatePickerComponent,
                            DynamicBootstrapInputComponent,
                            DynamicBootstrapRadioGroupComponent,
                            DynamicBootstrapSelectComponent,
                            DynamicBootstrapTextAreaComponent,
                            DynamicBootstrapTimePickerComponent,
                            DynamicBootstrapFormControlContainerComponent,
                            DynamicBootstrapFormComponent
                        ],
                        entryComponents: [
                            DynamicBootstrapCheckboxComponent,
                            DynamicBootstrapDatePickerComponent,
                            DynamicBootstrapInputComponent,
                            DynamicBootstrapRadioGroupComponent,
                            DynamicBootstrapSelectComponent,
                            DynamicBootstrapTextAreaComponent,
                            DynamicBootstrapTimePickerComponent
                        ],
                        exports: [
                            core$1.DynamicFormsCoreModule,
                            DynamicBootstrapFormControlContainerComponent,
                            DynamicBootstrapFormComponent
                        ]
                    },] },
        ];
        /** @nocollapse */
        DynamicFormsBootstrapUIModule.ctorParameters = function () { return []; };
        return DynamicFormsBootstrapUIModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    exports.DynamicBootstrapCheckboxComponent = DynamicBootstrapCheckboxComponent;
    exports.DynamicBootstrapDatePickerComponent = DynamicBootstrapDatePickerComponent;
    exports.DynamicBootstrapInputComponent = DynamicBootstrapInputComponent;
    exports.DynamicBootstrapRadioGroupComponent = DynamicBootstrapRadioGroupComponent;
    exports.DynamicBootstrapSelectComponent = DynamicBootstrapSelectComponent;
    exports.DynamicBootstrapTextAreaComponent = DynamicBootstrapTextAreaComponent;
    exports.DynamicBootstrapTimePickerComponent = DynamicBootstrapTimePickerComponent;
    exports.DynamicBootstrapFormComponent = DynamicBootstrapFormComponent;
    exports.DynamicBootstrapFormControlContainerComponent = DynamicBootstrapFormControlContainerComponent;
    exports.bootstrapUIFormControlMapFn = bootstrapUIFormControlMapFn;
    exports.DynamicFormsBootstrapUIModule = DynamicFormsBootstrapUIModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-bootstrap.umd.js.map
